<?

if (file_exists(PRISCILLA_LOCAL_PATH."modules/swaplang/inc/config.inc.php"))
    require_once PRISCILLA_LOCAL_PATH."modules/swaplang/inc/config.inc.php";

require_once PRISCILLA_LOCAL_PATH."modules/swaplang/lib/swaplang.lib.php";

// per avere la tendina: swaplang oppure swaplang_combobox
// per avere la lista con ul: swaplang_list
/**
 ** tag: swaplang
 ** desc: crea una lista di lingue disponibili
 ** opt: type combobox|list combobox crea una tendina (default), list una lista non ordinata (ul, li)
 ** opt: labels coppie chiave valore nel formato: nome lingua in tre lettere:etichetta;prossimo nome lingua tre lettere:etichetta;
 ** eg: {swaplang type="combobox"}
 **/
function swaplang($connh, $row, &$PRISCILLA_SESSION, $options) {

    if (defined('SWAPLANG_ACTIVE') && SWAPLANG_ACTIVE === false)
        return;

    if (!$_GET['id'])
        $id = 1;
    else
        $id = $_GET['id'];

    $subst = "<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."\" id=\"swaplangform\">\n<fieldset>";

    if (!$options['type'])
        $options['type'] = 'combobox';

    if ($options['type'] == 'combobox')
        $subst .= "<select name=\"swaplang\" id=\"swaplang\" onchange=\"document.getElementById('swaplangform').submit();\" class=\"swaplangclass\">\n";
    else if ($options['type'] == 'list')
        $subst .= "<input type=\"hidden\" id=\"swaplang\" name=\"swaplang\" />\n";

    $subst .= swaplang_options($connh, $id, $PRISCILLA_SESSION, $options);

    if ($options['type'] == 'combobox')
        $subst .= "</select></fieldset></form>\n";
    else if ($options['type'] == 'list')
        $subst .= "</fieldset></form>\n";

    return $subst;
}

function swaplang_options($connh, $id, $PRISCILLA_SESSION, $options)
{
    $subst = '';

    $result = $connh->MetaTables();
    $i = 0;

    $rscontent = $connh->Execute("SELECT contenuto FROM node WHERE id='".$id."'");
    $contenuto = $rscontent->fields['contenuto'];

    // standard labels
    getLanguagesStruct($langlabels, $langs);
    
    if (trim($options['labels'])) {
        foreach (explode(';', $options['labels']) as $l) {
            if (trim($l)) {
                $label = explode(':', $l);
                $opt_labels[$label[0]] = $label[1];
            }
        }
    }

    if ($options['type'] == 'list')
        $subst .= '<ul class="swaplangul">';

    if (!in_array($contenuto.'_lang'.SWAPLANG_DEFAULT_LANG, $result)) {

        if (isset($opt_labels[SWAPLANG_DEFAULT_LANG]))
            $langname = $opt_labels[SWAPLANG_DEFAULT_LANG];
        else
            $langname = getlangname(SWAPLANG_DEFAULT_LANG);

        $selected = '';
        $current_lang_class = '';
        if ($PRISCILLA_SESSION->getvalue('priscilla_swaplang_content') == $contenuto || $PRISCILLA_SESSION->getvalue('priscilla_swaplang_content') == '') {
            $selected = 'selected="selected"';
            $current_lang_class = 'swaplangcurrent';
        }

        if ($options['type'] == 'combobox')
            $subst .= "<option value=\"".$contenuto."\" $selected>".$langname."</option>\n";
        else if ($options['type'] == 'list')
            $subst .= "<li id=\"swaplangli$i\" class=\"swaplangli $current_lang_class\"><a onclick=\"javascript:document.getElementById('swaplang').value='".$contenuto."';document.getElementById('swaplangform').submit();\" href=\"javascript:;\" id=\"swaplanga$i\">".$langname."</a></li>\n";
        else if ($options['type'] == 'array')
            $subst[$i] = array($contenuto, $langname, $selected);
        $i++;
    }

    $currentlang = getlLangFromContent($PRISCILLA_SESSION->getvalue('priscilla_swaplang_content'), $langs);

    foreach ($langs[$contenuto] as $tbname => $lang) {

        if (isset($opt_labels[$lang]))
            $langname = $opt_labels[$lang];
        else
            $langname = getlangname($lang);

        $selected = '';
        $current_lang_class = '';
        if ($currentlang == $lang && !$selected) {
            $selected = 'selected="selected"';
            $current_lang_class = 'swaplangcurrent';
        }

        if ($options['type'] == 'combobox')
            $subst .= "<option value=\"".$tbname."\" $selected>".$langname."</option>\n";
        else if ($options['type'] == 'list')
            $subst .= "<li id=\"swaplangli$i\" class=\"swaplangli $current_lang_class\"><a onclick=\"javascript:document.getElementById('swaplang').value='".$tbname."';document.getElementById('swaplangform').submit();\" href=\"javascript:;\" id=\"swaplanga$i\">".$langname."</a></li>\n";
        else if ($options['type'] == 'array')
            $subst[$i] = array($tbname, $langname, $selected);

        $i++;
    }

    if ($options['type'] == 'list')
        $subst .= '</ul>';

    return $subst;
}

?>
